/*
 * Created on 18.2.2005
 */
package fi.helsinki.dacopan.ui.tsc;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.util.Iterator;
import java.util.List;

import javax.swing.JPanel;
import javax.swing.JTextArea;

import fi.helsinki.dacopan.Localization;
import fi.helsinki.dacopan.model.TransferUnit;
import fi.helsinki.dacopan.model.VariableDefinition;
import fi.helsinki.dacopan.ui.MainFrame;
import fi.helsinki.dacopan.ui.TitlePanel;

public class PacketInfoPanel extends JPanel {
	private JTextArea infoArea;
	private NoteBar noteBar = null;
    private TSCNotePanel notePanel = null; 
    private MainFrame main = null; 
    private DrawingArea area = null;
    
    public PacketInfoPanel() {        
        initComponents();
    }
    
	public PacketInfoPanel(NoteBar noteBar,TSCNotePanel notePanel, MainFrame main,DrawingArea area)
	{
        this.noteBar = noteBar;
        this.notePanel = notePanel;
        this.main = main;
        this.area = area;
        
        this.setMinimumSize(new Dimension(320,240));
        
		initComponents();
	}
    
    public void setNoteBar(NoteBar noteBar) {
    	this.noteBar = noteBar;
    }
    public void setNotePanel(TSCNotePanel notePanel) {
    	this.notePanel = notePanel;
    }
    public void setMainFrame(MainFrame frame) {
    	this.main = frame;
    }
    public void setDrawingArea(DrawingArea area) {
    	this.area = area;
        
    }
    
    
    private SettingsTSC getSettings() {
    	return main.getSettings().getSettingsTSC();
    }

	private void initComponents() {
		JPanel jPanelTitle = new TitlePanel(Localization.getString("panel.tsc.packetinfo.title"), null);        
        setLayout(new java.awt.BorderLayout());
        
        infoArea = new JTextArea();        
        infoArea.setEditable(false);        
        infoArea.setEnabled(false);
        infoArea.setDisabledTextColor(Color.BLACK);
        infoArea.setForeground(Color.BLACK);
        
		add(jPanelTitle, java.awt.BorderLayout.NORTH);        
        add(infoArea, java.awt.BorderLayout.CENTER);               
        
	}

    public void clear() {
    	infoArea.setText("");
    }
    
    public void paintComponent(Graphics g) {
        TransferUnit u = null;
        clear();
    	if(area != null && (u = area.getActiveUnit()) != null) {
            List variables = u.getProtocol().getVariables();
            Iterator  iter = variables.iterator();
            SettingsTSC settings = getSettings();
            
            while(iter.hasNext()) {
                VariableDefinition var = (VariableDefinition) iter.next();
                if(settings.isVariableDisplayed(var.getRawName())) {      
                    if(u.getValue(var)!=null) {
                        infoArea.append(var.getName() + " = " + u.getValue(var) +"\n");
                    }
                }
            }

            if(noteBar != null) {
                noteBar.displayUnitNotice(u);
            } 
            if(notePanel != null) {
                notePanel.displayUnitNote(u);
            }       

    	} else {
    		notePanel.clear();
        }
    }
}
