/*
 * Created on Apr 24, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package fi.helsinki.dacopan.ui.tsc;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import fi.helsinki.dacopan.Localization;
import fi.helsinki.dacopan.model.Note;
import fi.helsinki.dacopan.model.TransferUnit;
import fi.helsinki.dacopan.ui.MainFrame;

/**
 * @author mikkoa 
 */
public class TSCNotePanel extends JPanel implements ActionListener{
    private MainFrame main;
    
    private TransferUnit unit;
    private Note note;
    
    //Gui Widgets
    private JTextArea textArea;
    private JButton btnAdd;
    
    private JButton btnDelete;
    private JButton btnEdit;
    
    private JScrollPane scrollPane;
    
    
    public TSCNotePanel(MainFrame main) {
        this.main = main;    
        
        initComponents();
    }
    
    public void setSelectedUnit(TransferUnit unit) {
    	this.unit = unit;
    }
    
    private void initComponents() {
        
        
    	this.setLayout(new BorderLayout());
        textArea = new JTextArea();
        textArea.setLineWrap(true);
        textArea.setEditable(false);
        
        scrollPane = new JScrollPane(textArea);
        this.add(scrollPane,BorderLayout.CENTER);        
        
        
        JPanel container = new JPanel();
        container.setLayout(new FlowLayout());
        this.add(container,BorderLayout.SOUTH);        
        
        btnAdd = new JButton(Localization.getString("panel.note.add_note"));
        btnAdd.addActionListener(this);
        btnAdd.setEnabled(false);
        container.add(btnAdd);
        
        
        btnEdit = new JButton(Localization.getString("panel.note.edit_note"));
        btnEdit.addActionListener(this);
        btnEdit.setEnabled(false);
        container.add(btnEdit);
        
        btnDelete = new JButton(Localization.getString("panel.note.delete_note"));
        btnDelete.addActionListener(this);
        btnDelete.setEnabled(false);
        container.add(btnDelete);
        
        
   
    }

    public void clear() {
    	unit = null;
        note = null;
        
        btnAdd.setEnabled(false);
        btnDelete.setEnabled(false);
        btnEdit.setEnabled(false);
    }
    
    public void displayUnitNote(TransferUnit u) {
        if(u == null) {
            unit = null;
        	btnAdd.setEnabled(false);
            btnDelete.setEnabled(false);
            btnEdit.setEnabled(false);
            return;
        }
        
        Note n = main.getNoteManager().getNoteTsc(u);
        unit = u;
        if(n != null) {
        	note = n;
            textArea.setText(note.getText());            
            btnEdit.setEnabled(true);
            btnDelete.setEnabled(true);
            btnAdd.setEnabled(false);
        } else {
            note = null;
            textArea.setText("");
        	btnAdd.setEnabled(true);
            btnEdit.setEnabled(false);
            btnDelete.setEnabled(false);
        }        
    }

    
    
	public void actionPerformed(ActionEvent e) {
        Object src = e.getSource();
        NoteDialog dialog;
        if(src.equals(btnAdd)) {
            dialog = new NoteDialog();
            dialog.newNote(unit);
        } else
        if(src.equals(btnEdit) && note != null) {
            dialog = new NoteDialog();
            dialog.editNote(note,unit);            
        } else
        if(src.equals(btnDelete) && note != null) {
            main.getNoteManager().deleteNote(note);
            note = null;
            textArea.setText("");
            btnEdit.setEnabled(false);
            btnDelete.setEnabled(false);
        } 
		
	}
    public void paintComponent(Graphics g) {
        btnDelete.setEnabled(note != null && unit != null);
        btnEdit.setEnabled(note != null && unit != null);
        btnAdd.setEnabled(note == null && unit != null);
        
        if(note == null) textArea.setText("");
    }
    
    private class NoteDialog extends JDialog implements ActionListener {
        private JButton btnSave;
        private JButton btnCancel;
    	private JTextArea textArea;        
        private Note myNote;
        private TransferUnit unit;
        
        public NoteDialog() {
        	this.initComponents();
            this.setSize(320,240);            
            this.setModal(false);
            this.setVisible(true);
        }
        
        public void initComponents() {
            this.setLayout(new BorderLayout());
            
            textArea = new JTextArea();
            textArea.setLineWrap(true);
            
            JScrollPane j = new JScrollPane(textArea);
            j.setSize(320,240);
            j.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
            
            this.add(j,BorderLayout.CENTER);            
            
            JPanel cont = new JPanel();
            cont.setLayout(new FlowLayout());            
            btnSave = new JButton(Localization.getString("panel.edit_note.save"));
            btnSave.addActionListener(this);
            
            btnCancel = new JButton(Localization.getString("panel.edit_note.cancel"));
            btnCancel.addActionListener(this);
            
            cont.add(btnSave);
            cont.add(btnCancel);
            
            this.add(cont,BorderLayout.SOUTH);                        
        }
        
        
        public void editNote(Note note,TransferUnit unit) {
        	this.myNote = note;
            this.unit = unit;
            textArea.setText(note.getText());            
        }
        
        public void newNote(TransferUnit unit) {
            if(unit != null) {
            	this.unit = unit;            
            	this.myNote = new Note(unit,"");
            } 
        }
        
        private void saveNote() {
            this.myNote.setText(textArea.getText());            
            main.getNoteManager().addNoteTsc(myNote);
            displayUnitNote(unit);            
            this.dispose();
        }
        private void cancel() {
        	this.dispose();
        }
        
        public void actionPerformed(ActionEvent e) {
            Object src = e.getSource();
            if(src.equals(btnSave)) {
                saveNote();                
            } else
            if(src.equals(btnCancel)) {
            	cancel();                
            }            
        }
    }
}
