/*
 * Created on 3.3.2005
 */
package fi.helsinki.dacopan.ui.tsc;

import java.awt.Dimension;
import java.awt.Graphics;

import javax.swing.JPanel;

import fi.helsinki.dacopan.Localization;

/**
 * @author mjvaanan
 */
public class Yaxis extends JPanel {
	
	private Label[] labels;
	private long first_seqno;
	private String title = Localization.getString("panel.tsc.yaxis.title");

	public Dimension getPreferredSize()
	{
		return new Dimension(100, 50);
	}
	
	public Dimension getMinimumSize()
	{
		return getPreferredSize();
	}
	
	void setLabels(Label[] labels) {
		this.labels = labels;
		if (labels != null && labels.length > 0) {
			first_seqno = labels[0].getSEQNO();
		}
	}
	
	private String getText(Label label) {
		long seqno = label.getSEQNO();
		return new Long(seqno).toString();
	}
	
	public void paintComponent(Graphics g) {
		g.drawString(title, 5, getSize().height - 5);
		if (labels != null) {
			for (int i = 0; i < labels.length; i++) {
				int y = labels[i].getPos();
				if (y > 10) {
					g.drawString(getText(labels[i]), 5, y);
				}
			}
		}
	}
	
	public static class Label {
		private int pos;
		private long seqno;
		
		public Label(int pos, long seqno) {
			this.pos = pos;
			this.seqno = seqno;
		}

		public int getPos() {
			return pos;
		}
		
		public long getSEQNO() {
			return seqno;
		}
	}
}
