package fi.helsinki.dacopan.model;

import java.util.Collections;
import java.util.LinkedList;

import fi.helsinki.dacopan.AbstractTestCase;

/**
 * Test case for the NoteManager.
 */
public class NoteManagerTestCase extends AbstractTestCase {
    
    DataView dataView;
    NoteManager noteManager;
    Note[] notes;
        
    public void setUp(){
        // Create data view
        dataView = new DefaultDataView();
        dataView.addHost(HOST_A);
        dataView.addHost(HOST_B);
        
        dataView.addLayer(NETWORK);
        dataView.addLayer(TRANSPORT);
        dataView.addLayer(APPLICATION);
                
        dataView.addProtocol(IPv4);
        dataView.addProtocol(TCP);
        dataView.addProtocol(HTTP);
    
        noteManager = new NoteManager();     
        
        Layer[] layers = new Layer[]{NETWORK,TRANSPORT,APPLICATION};
        //                               0    1    2    3    4    5    6    7    8    9
        float[] timeStamps = new float[]{100f,200f,300f,400f,500f,600f,700f,800f,900f,1000f};
        String[] texts = new String[timeStamps.length];
        notes = new Note[timeStamps.length];
        
        for (int j = 0; j < timeStamps.length; j++) {
        		texts[j] = "Note text. Time="+timeStamps[j]+", Layer="+layers[0];
                Note note = new Note(layers[0], timeStamps[j], texts[j]);
        		noteManager.addNoteTimeLayer(note);
                notes[j]=note;
        }
    }
			
    public void testGetNoteTimeLayerPrev(){
        noteManager.getClass();
        //TODO write a test case for this
    }

    public void testGetNoteTimeLayerNext(){
        noteManager.getClass();
        //TODO write a test case for this
    }
    
	public void testGetNotesInTimeRangeNetwork() {
        LinkedList constructedList = new LinkedList();
        constructedList.add(notes[5]);
        constructedList.add(notes[6]);
        constructedList.add(notes[7]);
	    LinkedList actualList = (LinkedList)noteManager.getNotesInTimeRange(NETWORK,510,810);
	    
	    assertListsHaveSameContent("Time Range", constructedList, actualList);
	}
	
    public void testENCNote() {
        
        // Add a note to the note manager
        TransferUnit testTU = 
            new TransferUnit(1, Collections.EMPTY_MAP, IPv4, null, HOST_A, HOST_B, 1.0f, 2.0f, false);
        Note testNote = new Note(testTU, "test note");
    	noteManager.addNoteEnc(testNote);
        
        // Try to read it
        assertEquals(noteManager.getNoteEnc(testTU),testNote);
    }
}
