/*
 * Created on 28.4.2005
 *
 */
package fi.helsinki.dacopan.model;

import fi.helsinki.dacopan.AbstractTestCase;

/**
 * @author pamietti
 *
 * JUnit test case for Note.
 */
public class NoteTestCase extends AbstractTestCase {

	
	private DataView data;
	private static final float DELTA = 0.00000001f;
	/*
	 * @see TestCase#setUp()
	 */
	protected void setUp() throws Exception {
		data = getRandomData(10, 10, 10, 0, false);
	}

	/*
	 * Class under test for void Note(Layer, float, String)
	 */
	public void testNoteLayerfloatString() {
		Note note = new Note(data.getLayerById(1), 0.0f, "T on meidn noutti");
	}

	/*
	 * Class under test for void Note(TransferUnit, String)
	 */
	public void testNoteTransferUnitString() {
		Note note = new Note(((TransferUnit)data.getUnitsForLayer(data.getLayerById(1)).get(0)), "T on meidn toinen noutti");
	}

	public void testSetAndGetText() {
		Note note = new Note(data.getLayerById(1), 0.0f, "T on meidn noutti");
		assertEquals("note texts are not same", "T on meidn noutti", note.getText());
		note.setText("Jipadapaduu");
		assertEquals("set note texts are not same", "Jipadapaduu", note.getText());
		note = new Note(((TransferUnit)data.getUnitsForLayer(data.getLayerById(1)).get(0)), "T on meidn toinen noutti");
		assertEquals("TransferUnit note texts are not same", "T on meidn toinen noutti", note.getText());
	}

	public void testGetTime() {
		Note note = new Note(data.getLayerById(1), 9.09f, "T on meidn noutti");
		assertEquals("note times are not same", 9.09f, note.getTime(), DELTA);
	}

	public void testGetLayer() {
		Note note = new Note(data.getLayerById(1), 9.09f, "T on meidn noutti");
		assertEquals("note layers are note same", data.getLayerById(1), note.getLayer());
	}

	public void testGetTransferUnit() {
		Note note = new Note(((TransferUnit)data.getUnitsForLayer(data.getLayerById(1)).get(0)), "T on meidn toinen noutti");
		assertEquals("note transfer units are not same", ((TransferUnit)data.getUnitsForLayer(data.getLayerById(1)).get(0)), note.getTransferUnit());
	}

	public void testCompareTo() {
		Note note = new Note(data.getLayerById(1), 9.09f, "T on meidn noutti");
		Note note2 = new Note(data.getLayerById(1), 9.10f, "T on meidn noutti");
		assertTrue("notes copares is not correct", note.compareTo(note2) == -1);
		
	}

	/*
	 * Class under test for boolean equals(Object)
	 */
	public void testEqualsObject() {
		Note note = new Note(data.getLayerById(1), 9.09f, "T on meidn noutti");
		Note note2 = new Note(data.getLayerById(1), 9.10f, "T on meidn noutti");
		assertTrue("notes are claimed to be equals", !note.equals(note2));
		assertTrue("notes are claimed to be different", note.equals(note));
	}

	/*
	 * Class under test for String toString()
	 */
	public void testToString() {
		Note note = new Note(data.getLayerById(1), 9.09f, "T on meidn noutti");
		assertEquals("notes toString is not correct", "T on meidn noutti / "+9.09f, note.toString());
	}

}
