package fi.helsinki.dacopan.ui;

import fi.helsinki.dacopan.AbstractTestCase;
import fi.helsinki.dacopan.model.DataView;
import fi.helsinki.dacopan.model.NoteManager;

/**
 * Example test class that sets up the MainFrame with a DataView
 * populated with random data.
 * 
 * @version $Id: ExampleUITest.java,v 1.5 2004/05/05 14:52:43 jbrown-dacopan Exp $
 */
public class ExampleUITest {
    
    public static void main(String[] args) {
        /*
         * Get a view populated with 8 app units that each contain
         * 2 transport units and those in turn contain 2 network units.
         * The last switch controls whether or not to dump all of
         * the units to console for debugging.
         */
        DataView view = AbstractTestCase.getRandomData(100, 5, 1, 0.2f, true);
        NoteManager noteManager = AbstractTestCase.getRandomNotes(view.getEndTime(), 50, view.getLayerById(1));
        MainFrame frame = new MainFrame(view, noteManager);
        frame.show();
    }
    
}
